//
// $Id: RegistryEffectiveRightsData.h,v 1.5 2005/03/28 15:59:43 bakerj Exp $
//
//****************************************************************************************//
// Copyright (c) 2005, The MITRE Corporation
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//     * Redistributions of source code must retain the above copyright notice, this list
//       of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice, this 
//       list of conditions and the following disclaimer in the documentation and/or other
//       materials provided with the distribution.
//     * Neither the name of The MITRE Corporation nor the names of its contributors may be
//       used to endorse or promote products derived from this software without specific 
//       prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
// EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
// SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
// OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
// TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//****************************************************************************************//
//
//  file:	RegistryEffectiveRightsData.h
//  author: Jon Baker	
//
//	This class will store all data for a windows registry key. 
//	The class is a child class of ProbeData and implments the Write() function.
//****************************************************************************************//

#ifndef __REGISTRYEFFECTIVERIGHTSDATA_H__
#define __REGISTRYEFFECTIVERIGHTSDATA_H__

#include "ProbeData.h"

using namespace std;

class RegistryEffectiveRightsData : public ProbeData
{
public:
	// -----------------------------------------------------------------------
	//	Constructors & Destructors
	// -----------------------------------------------------------------------	
	RegistryEffectiveRightsData(DOMElement *test);
	RegistryEffectiveRightsData();
	~RegistryEffectiveRightsData();

	// -----------------------------------------------------------------------
	//	Public members
	// -----------------------------------------------------------------------
	void Write();

	// -----------------------------------------------------------------------
	//	Public data
	// -----------------------------------------------------------------------	
	ObjectElement *hive;
	ObjectElement *key;
	DataElement *trustee_name;
	DataElement *trustee_domain;
	DataElement *trustee_sid;
	DataElement *acl_type;
	DataElement *standard_delete;;
	DataElement *standard_read_control;
	DataElement *standard_write_dac;
	DataElement *standard_write_owner;
	DataElement *standard_synchronize;
	DataElement *access_system_security;
	DataElement *generic_read;
	DataElement *generic_write;
	DataElement *generic_execute;
	DataElement *generic_all;
	DataElement *key_query_value;
	DataElement *key_set_value;
	DataElement *key_create_sub_key;
	DataElement *key_enumerate_sub_keys;
	DataElement *key_notify;
	DataElement *key_create_link;
	DataElement *key_wow64_64key;
	DataElement *key_wow64_32key;
	DataElement *key_wow64_res;

private:
	// -----------------------------------------------------------------------
	//	Private members
	// -----------------------------------------------------------------------
	void ParseNode(DOMElement *test);

	// -----------------------------------------------------------------------
	//	Private data
	// -----------------------------------------------------------------------
	// Store a string representation of each item collected
	static sVector items;
};

#endif